﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Olap.FlatData;
using System.Linq.Expressions;
using Infragistics.Controls.Charts;

namespace OlapAxis
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            FlatDataSource source = LayoutRoot.Resources["OlapFlatDataSource"] as FlatDataSource;

            HierarchyDescriptor dateTimeDescriptor = new HierarchyDescriptor { AppliesToPropertiesOfType = typeof(DateTime) };
            dateTimeDescriptor.AddLevel<DateTime>(dt => dt.Year, "Years");
            dateTimeDescriptor.AddLevel<DateTime>(dt => dt.SemesterShort(), "Semesters");
            dateTimeDescriptor.AddLevel<DateTime>(dt => dt.QuarterShort(), "Quarters");
            dateTimeDescriptor.AddLevel<DateTime>(dt => dt.MonthShort(), "Months");
            // set the sort order of months

            //Expression<Func<DateTime, int>> expression = pd => pd.Month;
            //dateTimeDescriptor.LevelDescriptors[4].OrderByKeyExpression = expression;
            //dateTimeDescriptor.AddLevel<DateTime>(dt => dt.Date.ToShortDateString(), "Dates");

            source.HierarchyDescriptors.Add(dateTimeDescriptor);

           // FlatDataSource source = LayoutRoot.Resources["OlapFlatDataSource"] as FlatDataSource;

            var numericYAxis = new NumericYAxis()
            {
                LabelSettings = new AxisLabelSettings()
                {
                    Extent = 55,
                    Location = AxisLabelsLocation.OutsideLeft,
                    IsHitTestVisible = true
                }
            };

            DataChart.Axes.Add(numericYAxis);

            OlapXAxis olapXAxis = new OlapXAxis();
            olapXAxis.YAxis = numericYAxis;
            olapXAxis.Label = "{Label}";
            olapXAxis.OlapAxisSource = OlapAxisSource.Rows;
            olapXAxis.LabelSettings = new AxisLabelSettings();
            olapXAxis.LabelSettings.Extent = 35;
            olapXAxis.LabelSettings.Location = AxisLabelsLocation.OutsideBottom;

            olapXAxis.DataSource = source;

            DataChart.Axes.Add(olapXAxis);

        }

        private void DataChart_Loaded(object sender, RoutedEventArgs e)
        {
          

        }
    }
}
